/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.SimpleDateFormat;
import java.util.TimeZone;


/**
 * 
 * @author Alexander Arimond
 *
 */
public class TimeMeasurement {

	private long start;
	private long now;
	
	public TimeMeasurement(){
		start = System.currentTimeMillis(); // some initalizing
	}
	
	public void start(){
		start = System.currentTimeMillis();
	}
	
	public void stop(){
		now = System.currentTimeMillis();
	}
	
	public String format(){
		if (now == 0 || now < start){
			stop();
		}
		long difference = now - start;
        TimeZone.setDefault(TimeZone.getTimeZone("GMT"));
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss:SSS");
        return sdf.format(difference);
	}
	
	public String fileFormat(String message){
		String format = format();
		long difference = now - start;
		return message + " " + difference + " " + format + "\n";
	}
	
	public void print(String message){
		System.out.println(message + format());
	}
	
	public void print(){
		System.out.println(format());
	}

	public void printAfter(String message) {
		System.out.println(format() + message);
	}
	
	public void appendToFile(File file, String message){
		boolean append = true;
		try {
			file.createNewFile();
			BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, append)));
			out.write(fileFormat(message));
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
