/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */

package de.arimond.dt.operators.distribution;

import java.io.Serializable;

/**
 * 
 * @author Alexander Arimond
 *
 * @param <S>
 * @param <M>
 * @param <O>
 */

public abstract class Distribution <S extends Serializable, M extends Serializable, O extends Serializable>{

	public static int nr_threads;
	
	protected DistributionMapReduce<S, M, O> spec;
	
	protected int numberMaps;
	
	public Distribution(DistributionMapReduce <S, M, O> spec){
		this.spec = spec;
		// FIXME default
		this.numberMaps = 10;
	}
	
	protected DistributionMapReduce <S,M,O> getMapReduceSpecification(){
		return this.spec;
	}
	
	public abstract O startComputation() throws DistributionException ; 
	
	public abstract void provideMapInputData(int mapNr, S data);
	
	public abstract void provideMapData(int mapNr, Serializable key, Serializable data);
	
	public abstract void provideStaticData(Serializable key, Serializable data);

	public void setNumberMaps(int nrMaps) {
		this.numberMaps = nrMaps;
		
	}

	public void setMapReduceSpecification(DistributionMapReduce<S,M,O> spec){
		this.spec = spec;
	}
	
	public int getNumberMaps(){
		return this.numberMaps;
	}
	
	public abstract void clearData();

	public abstract Serializable getStaticData(Serializable key);

	public abstract Serializable getMapData(int mapNr, Serializable key);

}
