/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution;

import java.io.Serializable;

/**
 * 
 * @author Alexander Arimond
 *
 * @param <S>
 */

public abstract class DistributionDataLayer <S extends Serializable>{
	
	public abstract void putMapInputData(int mapNr, S input);

	public abstract S getMapInputData(int mapNr);
	
	public abstract void putMapData(int mapNr, Serializable key, Serializable data); 
	
	public abstract Serializable getMapData(int mapNr, Serializable key);
	
	public abstract void putData(Serializable key, Serializable data);
	
	public abstract Serializable getData(Serializable key);

	public abstract void clearData();
	
}
