/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution.clustering;

import java.io.Serializable;

public class Assignments implements Serializable {

	/**
	 * @author Alexander Arimond
	 */
	private static final long serialVersionUID = 3873661955966492744L;
	private final int[] centroidAssignments;
	private final double[][] centroidSums;
	private final int[] nrOfAssigns;
//	public final int beginIndex;
//	public final int size;
	private Integer split_nr;

//	public Assignments(int[] centroidAssignments, double[][] centroidSums,
//			int[] nrOfAssigns, int beginIndex, int size) {
//
//		this.beginIndex = beginIndex;
//		this.size = size ;
//	}
	
	public Assignments(Integer split_nr, int[] centroidAssignments,
			double[][] centroidSums, int[] nrOfAssigns) {
		this.split_nr = split_nr;
		this.centroidAssignments = centroidAssignments;
		this.centroidSums = centroidSums;
		this.nrOfAssigns = nrOfAssigns;
	}

	public int [] getCentroidAssignments(){
		return centroidAssignments;
	}
	
	public double [][] getCentroidSums(){
		return centroidSums;
	}
	
	public int [] getNrOfAssigns(){
		return nrOfAssigns;
	}
	
	public Integer getSplitNr(){
		return split_nr;
	}
	
}
