/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution.clustering;

import java.io.Serializable;

import com.rapidminer.operator.clustering.CentroidClusterModel;

/**
 * 
 * @author Alexander Arimond
 *
 */

public class KMeansResult implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7047989299944640730L;
	private CentroidClusterModel model;
	private int[] assignments;

	public KMeansResult (CentroidClusterModel model, int [] assignments){
		this.model = model;
		this.assignments = assignments;
	}
	
	public CentroidClusterModel getModel(){
		return model;
	}
	
	public int []getAssignments(){
		return assignments;
	}
	
}
