package de.arimond.dt.operators.distribution.clustering2;

import java.io.Serializable;

import com.rapidminer.operator.clustering.CentroidClusterModel;
import com.rapidminer.operator.clustering.clusterer.DistanceMatrix;
import com.rapidminer.tools.math.similarity.DistanceMeasure;

/**
 * 
 * @author Alexander Arimond
 *
 */

public class ClusterDistances implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1391184628028307442L;
	public final DistanceMatrix matrix;
	public final double[] s;

	public ClusterDistances(int k){
		this.matrix = new DistanceMatrix(k);
		this.s = new double [k];
	}

	// this is for step 1 of the paper algorithm
	public void compute(CentroidClusterModel model,  DistanceMeasure measure) {
		for (int i = 0; i < model.getNumberOfClusters(); i++){
			s[i] = Double.POSITIVE_INFINITY;
		}
		for (int i = 0; i < model.getNumberOfClusters(); i++){
			for (int j = i+1; j < model.getNumberOfClusters(); j++){
				final double d = measure.calculateDistance(model.getCentroidCoordinates(i), model.getCentroidCoordinates(j));
				if (d < s[i]){
					s[i] = d;
				}
				if (d < s[j]){
					s[j] = d;
				}
				matrix.set(i, j, d);
			}
		}
		for (int i = 0; i < model.getNumberOfClusters(); i++){
			s[i] = 0.5 * s[i];
		}
	}
	
}
