/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution.clustering2;

import java.io.Serializable;

import com.rapidminer.example.ExampleSet;

/**
 * 
 * @author Alexander Arimond
 *
 */
public class SplitInformation implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1274371738757554613L;
	private final int nr;
	private final int size;
	public final int [] c;
	public final double [][] l;
	public final double [] u;
	public final boolean [] r;
	private String splitKey;
	
	public SplitInformation(ExampleSet split, int nr, int k){
		this.nr = nr;
		this.size = split.size();
		c = new int [size];
		l = new double[size][k];
		u = new double [size];
		r = new boolean[size];
		initializeFields();
	}
	
	public int getNr (){
		return this.nr;
	}

	public void initializeFields() {
		for (int i = 0; i < size; i ++){
			c[i] = 0;
			for (int j = 0; j < l[0].length; j ++){
				l[i][j] = 0.0;
			}
			u[i] = 0;
			r[i] = false;
		}
		
	}
	
	public int getSize() {
		return size;
	}
}
