/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution.coherence;

import java.io.Serializable;
import java.util.UUID;

/**
 * 
 * @author Alexander Arimond
 *
 */

public class MapDataKey implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -2927145551423112568L;
	private final MapDataKey associated;
	private final String key;

	public MapDataKey(UUID uuid, int nr){
		this.key = uuid.toString()+ "_" + nr;
		this.associated = null;
	}
	
	public MapDataKey(UUID uuid, int nr, Serializable key){
		this.key = uuid.toString() + "_" + nr + "_" + key.toString();
		this.associated = new MapDataKey(uuid, nr);
	}

	public boolean equals(Object obj){
		if (obj != null && obj instanceof MapDataKey && ((MapDataKey) obj).key.equals(this.key)){
			return true;
		} else return false;
	}
	
	public String toString(){
		return key;
	}

	//@Override
	public Object getAssociatedKey() {
		return associated;
	}
	
}
