/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution.hadoop;

import java.io.Serializable;

import org.apache.hadoop.mapred.JobConf;

import de.arimond.dt.operators.distribution.DistributionMapReduce;

/**
 * 
 * @author Alexander Arimond
 *
 * @param <S>
 * @param <M>
 * @param <O>
 */

public class DistributionJobConf<S extends Serializable, M extends Serializable, O extends Serializable> extends JobConf {

	public DistributionJobConf(){
		// nothing
	}
	
	public DistributionJobConf (JobConf conf){
		super(conf);
	}
	
	public void setMapReduceSpec(DistributionMapReduce <S,M,O> spec){
		this.set("distribution.mapreduce.spec", spec.getClass().getCanonicalName());
	}
	
	public DistributionMapReduce<S,M,O> getMapReduceSpec() throws InstantiationException, IllegalAccessException, ClassNotFoundException{
			return (DistributionMapReduce<S,M,O>) Class.forName(this.get("distribution.mapreduce.spec")).newInstance();
	}
	
}
 