/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.operators.distribution.images;

import java.io.Serializable;
import java.util.List;

import de.arimond.dt.operators.distribution.DistributionDataLayer;
import de.arimond.dt.operators.distribution.DistributionMapReduce;
import de.arimond.dt.operators.images.ImageObject;
import de.arimond.dt.operators.images.ImageObjectList;

/**
 * 
 * @author Alexander Arimond
 *
 */

public class SimpleImageDistributionSpec extends DistributionMapReduce<ImageObject, ImageObject, ImageObjectList>
		implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6522851246846007978L;

	@Override
	public ImageObject map(DistributionDataLayer <ImageObject> dataLayer, int mapNr) throws Exception {
		ImageObject image = dataLayer.getMapInputData(mapNr);
		System.out.println(image.getFilename());
		return image;
	}

	@Override
	public ImageObjectList reduce(List<ImageObject> mapResults,
			DistributionDataLayer <ImageObject> dataLayer) throws Exception {
		
		ImageObjectList list = new ImageObjectList(mapResults);
		return list;
	}

}
