package de.arimond.dt.operators.distribution.test;

import com.rapidminer.operator.clustering.Centroid;

import de.arimond.dt.operators.distribution.Distribution;
import de.arimond.dt.operators.distribution.DistributionFactory;
import de.arimond.dt.operators.distribution.DistributionFactory.DistributionDataLayerType;
import de.arimond.dt.operators.distribution.DistributionFactory.DistributionType;
import de.arimond.dt.operators.distribution.gridgain.Grid;

public class DistributionTesting {
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		try {
			Grid.startGridCoherence();
			Distribution <DataBlock, DataBlock, DataBlock> distribution = DistributionFactory.create(DistributionType.GRIDGAIN, DistributionDataLayerType.COHERENCE, new DistributionTestingSpec());
			
			// Distribution <DataBlock, DataBlock, DataBlock> distribution = DistributionFactory.create(DistributionType.HADOOP, DistributionDataLayerType.COHERENCE, new DistributionTestingSpec());
			
			int nr_maps = 10;
			
			for (int i = 0; i < nr_maps ; i++){
				distribution.provideMapInputData(i, new DataBlock(10));
				distribution.provideMapData(i, "map_data", new DataBlock(1));
			}
			
			distribution.setNumberMaps(nr_maps);
			
			
			for (int j= 0; j < 10; j++){
				DataBlock staticBlock = new DataBlock(10);
				staticBlock.setCentroid(new Centroid(4));
				distribution.provideStaticData("static_data", staticBlock );

				DataBlock resultBlock = distribution.startComputation();
				assert resultBlock != null;

			}
			distribution.clearData();
		} catch (Exception e) {
			throw e;
		} finally {
			Grid.stopGrid();
		}
		
	}

}
