package de.arimond.dt.operators.distribution.test;

import java.util.List;

import org.gridgain.grid.logger.GridLogger;

import de.arimond.dt.TimeMeasurement;
import de.arimond.dt.operators.distribution.DistributionDataLayer;
import de.arimond.dt.operators.distribution.gridgain.GridGainMapReduce;

public class DistributionTestingSpec extends
		GridGainMapReduce<DataBlock, DataBlock, DataBlock> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2428103992265700788L;
	
	@Override
	public DataBlock map(DistributionDataLayer<DataBlock> dataLayer, int mapNr)
			throws Exception {
		
		System.out.println("getMap");
		// load data
		TimeMeasurement time = new TimeMeasurement();
		time.start();
		DataBlock input = (DataBlock)dataLayer.getMapInputData(mapNr);
		if (input == null) throw new NullPointerException("input must not be null");
		time.stop();
		System.out.println("gotMap");
		//time.print("loadingTime map data: ");
		
//		GridLogger logger = getLogger();
//		if (logger.isDebugEnabled())
//			logger.debug("WHAT");
		
		
		time.start();
		DataBlock staticB = (DataBlock) dataLayer.getData("static_data");
		if (staticB == null) throw new NullPointerException("static data block must not be null");
		time.stop();
		
		// load map colocated data
		time.start();
		DataBlock block = (DataBlock) dataLayer.getMapData(mapNr, "map_data");
		if (block == null) throw new NullPointerException("datablock must not be null");
		time.stop();
		//time.print("loadingTime map colocated data: ");
		

		//time.print("loadingTime static data in map: ");
		
		System.out.println("working 1 sec..");
		Thread.sleep(1000);
		
		return new DataBlock(1 * DataBlock.MB);
	}

	@Override
	public DataBlock reduce(List<DataBlock> mapResults,
			DistributionDataLayer<DataBlock> dataLayer) throws Exception {
		
		TimeMeasurement time = new TimeMeasurement();
		time.start();
		dataLayer.getData("static_data");
		time.stop();
		//time.print("loadingTime static data reduce: ");
		
		System.out.println("working 1 sec..");
		Thread.sleep(1000);
		
		return new DataBlock(1 * DataBlock.MB);
	}

}
