/*
 *  RapidMiner DisPaRe
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.arimond.dt.preprocessing;



import java.awt.image.BufferedImage;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.imageio.ImageIO;

import com.sun.media.jai.codec.ImageCodec;
import com.sun.media.jai.codec.ImageEncoder;
import com.sun.media.jai.codec.PNMEncodeParam;

/**
 * with help of java JAI
 * @author Alexander Arimond
 *
 */

public class GrayScaleImageConverter {

	/**
	 * 
	 * 
	 * @param file
	 * @param dest
	 * @param format
	 * @throws IOException
	 * @throws NoClassDefFoundError if JAI library is not in classpath
	 */
	
	public static void grayImage(File file, File dest, String format) throws IOException, NoClassDefFoundError{
		final BufferedImage bufferedImage = ImageIO.read(file);
		final BufferedImage grayScaleImage = new BufferedImage(bufferedImage.getWidth(), bufferedImage.getHeight(), BufferedImage.TYPE_BYTE_GRAY);
		grayScaleImage.getGraphics().drawImage(bufferedImage, 0, 0, null);
		
		FileOutputStream out = new FileOutputStream(dest);
		PNMEncodeParam param = new PNMEncodeParam();
		param.setRaw(true);
		ImageEncoder encoder = ImageCodec.createImageEncoder("PNM",	out, param);
		encoder.encode(grayScaleImage);
		out.close();
	}
}
